//This is a modified version of microsofts ZMouse.H
{$D-,L-} {Remove if you wish to debug this code}
unit inmoulow;

interface
uses windows,messages;
(****************************************************************************
*                                                                           *
* ZMOUSE.H -- Include file for IntelliMouse(tm) 1.0                         *
*                                                                           *
* NOTE:  Zmouse.h contains #defines required when providing IntelliMouse    *
*        wheel support for Windows95 and NT3.51.  Wheel is supported        *
*        natively in WinNT4.0, please refer to the NT4.0 SDK for more info  *
*        on providing support for IntelliMouse in NT4.0.                    *
*                                                                           *
* Copyright (c) 1983-1996, Microsoft Corp. All rights reserved.             *
*                                                                           *
****************************************************************************)


(**************************************************************************
	 Client Appplication (API) Defines for Wheel rolling
***************************************************************************)


// Apps need to call RegisterWindowMessage using the #define below to
// get the message number that is sent to the foreground window
// when a wheel roll occurs

Const MSH_MOUSEWHEEL = 'MSWHEEL_ROLLMSG';
   // wParam = wheel rotation expressed in multiples of WHEEL_DELTA
   // lParam is the mouse coordinates

      WHEEL_DELTA =  120;      // Default value for rolling one notch
      WM_MOUSEWHEEL = (WM_MOUSELAST+1);  // message that will be supported
                                        // by the OS


(**************************************************************************
    Client Appplication (API) Defines for
	   *  determining if wheel support active
	   *  determining # of Scroll Lines
***************************************************************************)

    MOUSEZ_CLASSNAME = 'MouseZ';            // wheel window class
    MOUSEZ_TITLE     = 'Magellan MSWHEEL';  // wheel window title

    MSH_WHEELMODULE_CLASS = MOUSEZ_CLASSNAME;
    MSH_WHEELMODULE_TITLE = MOUSEZ_TITLE;

// Apps need to call RegisterWindowMessage using the #defines
// below to get the message numbers for:
// 1) the message that can be sent to the MSWHEEL window to
//    query if wheel support is active (MSH_WHEELSUPPORT)>
// 2) the message to query for the number of scroll lines
//    (MSH_SCROLL_LINES)
//
    MSH_WHEELSUPPORT ='MSH_WHEELSUPPORT_MSG'; // name of msg to send
                                                 // to query for wheel support
                                                 //    wParam - not used
                                                 //    lParam - not used
                                                 //    returns BOOL - TRUE if wheel support is active, FALSE otherwise


     MSH_SCROLL_LINES = 'MSH_SCROLL_LINES_MSG';
                                               //    wParam - not used
                                               //    lParam - not used
                                               //    returns int  - number of lines to scroll on a wheel roll

    WHEEL_PAGESCROLL = $FFFFFFFF;   // signifies to scroll a page, also
                                   // defined in winuser.h in the
                                   // NT4.0 SDK

   SPI_SETWHEELSCROLLLINES  = 105;  // Also defined in winuser.h in the
                                       // NT4.0 SDK, please see the NT4.0 SDK
                                       // documentation for NT4.0 implementation
                                       // specifics.
                                       // For Win95 and WinNT3.51,
                                       // Mswheel broadcasts the message
                                       // WM_SETTINGCHANGE (equivalent to
                                       // WM_WININICHANGE) when the scroll
                                       // lines has changed.  Applications
                                       // will recieve the WM_SETTINGCHANGE
                                       // message with the wParam set to
                                       // SPI_SETWHEELSCROLLLINES.  When
                                       // this message is recieved the application
                                       // should query Mswheel for the new
                                       // setting.


(*********************************************************************
* INLINE FUNCTION: HwndMsWheel
* Purpose : Get a reference to MSWheel Window, the registered messages,
*           wheel support active setting, and number of scrollLines
* Params  : PUINT puiMsh_MsgMouseWheel - address of UINT to contain returned registered wheel message
*           PUINT puiMsh_Msg3DSupport - address of UINT to contain wheel support registered message
*           PUINT puiMsh_MsgScrollLines - address of UINT to contain Scroll lines registered message
*           PBOOL pf3DSupport - address of BOOL to contain returned flag for wheel support active
*           PINT  piScrollLines - address of int to contain returned scroll lines
* Returns : HWND handle to the MsWheel window
* Note    : The return value for pf3DSupport and piScrollLines is dependant
*           on the POINT32 module.  If POINT32 module is not running then
*           the values returned for these parameters will be
*           FALSE and 3, respectively.
*********************************************************************)
function HwndMSWheel(var uiMsh_MsgMouseWheel,
                         uiMsh_Msg3DSupport,
                         uiMsh_MsgScrollLines : Integer;
                     var f3DSupport : Bool;
                     var iScrollLines : Integer) : THandle;

var
 mswheel : THandle;
 _3dSupport : Bool;
 ScrollLines,
 MsgMouseWheel,
 Msg3DSupport,
 MsgScrollLines : Integer;
implementation

function HwndMSWheel(var uiMsh_MsgMouseWheel,
                         uiMsh_Msg3DSupport,
                         uiMsh_MsgScrollLines : Integer;
                     var f3DSupport : Bool;
                     var iScrollLines : Integer) : THandle;
begin
  result:=FindWindow(MSH_WHEELMODULE_CLASS, MSH_WHEELMODULE_TITLE);
  uiMsh_MsgMouseWheel := RegisterWindowMessage(MSH_MOUSEWHEEL);
  uiMsh_Msg3DSupport := RegisterWindowMessage(MSH_WHEELSUPPORT);
  uiMsh_MsgScrollLines := RegisterWindowMessage(MSH_SCROLL_LINES);
  if uiMsh_Msg3DSupport<>0 then
    f3DSupport := BOOL(SendMessage(result, uiMsh_Msg3DSupport, 0, 0))
  else
    f3DSupport := FALSE;  // default to FALSE

   if uiMsh_MsgScrollLines<>0 then
     iScrollLines := SendMessage(result, uiMsh_MsgScrollLines, 0, 0)
   else
     iScrollLines := 3;  // default
end;

initialization
  mswheel:=HwndMSWheel(MsgMouseWheel,Msg3DSupport,MsgScrollLines,_3DSupport,ScrollLines);
finalization
end.
