(*************************************************
This Source Code remains Copyrighted to
CopyRight (c) 1997 PA van Lonkhuyzen

Thanks to Jacques Scoatarin (j.scoatarin@cytanet.com.cy)
who wrote the parent subclassing code.

It may be distributed freely without restrictions

This Component allows you to easily implement support for
Microsofts Intellimouse.

There is only 1 new event.
On Wheel : This gets triggered whenever the mouse wheel is turned.
           mousex,mousey are the coordinates where the wheel was turned.
           movement is the amount the wheel was turned. with the sign
           designating up or down. 

The Author may be contacted via
email peterv@global.co.za
post P A van Lonkhuyzen
     PO Box 1041
     Randpark Ridge
     2156
     South Africa
***************************************************)
{$D-,L-} {Remove if you wish to debug this code}
unit Intelli;

interface

uses
  Windows, Messages, Forms,Classes;

type
  TIntelliEvent = Procedure (Sender : TObject;Mousex,Mousey,Movement : Integer) of Object;
  TIntellimouse = class(TComponent)
  private
    FDestroy : Boolean;
    FParentForm: TForm;
    FParentInstance: Pointer;
    FDefParentProc: Pointer;
    FOnWheel : TIntelliEvent;
  protected
    procedure ParentWndProc(var Message: TMessage);
  public
    procedure loaded; override;
    destructor destroy; override;
    procedure undosubclass;
    procedure subclass;
  published
    property Onwheel : TIntelliEvent read FOnwheel write FOnwheel;
  end;

procedure Register;

implementation
uses inmoulow;

procedure TIntellimouse.ParentWndProc(var Message: TMessage);
var P : TPoint;
begin
  with Message do
  begin
    if Msg = msgmousewheel then
    begin
      if assigned(FOnwheel) then
      begin
        P.X:=lparamlo;
        P.Y:=LParamhi;
        p:=fparentform.ScreenToClient(p);
        FOnwheel(self,p.x,p.y,wparam div wheel_delta);
      end;
      result:=0
    end
    else
    begin
      if msg=WM_DESTROY then
        FDestroy:=true;
      Result := CallWindowProc(FDefParentProc, FParentForm.Handle, Msg, WParam, LParam);
    end;
  end;
end;

procedure TIntellimouse.loaded;
begin
  inherited;
  subclass;
end;

destructor TIntellimouse.destroy;
begin
  undosubclass;
  inherited;
end;

procedure TIntellimouse.undosubclass;
begin
 if not FDestroy then
 begin
   if Assigned(FParentForm) and IsWindow(FParentForm.Handle) then
     SetWindowLong(FParentForm.Handle, GWL_WNDPROC, Longint(FDefParentProc));
   FreeObjectInstance(FParentInstance);
 end;
 FParentForm:=nil;
end;

procedure TIntellimouse.subclass;
begin
  if not (csdesigning in componentstate) then
  begin
    FDestroy:=False;
    FParentForm := Owner as TForm;
    FParentInstance := MakeObjectInstance(ParentWndProc);
    FDefParentProc := Pointer(GetWindowLong(FParentForm.Handle, GWL_WNDPROC));
    SetWindowLong(FParentForm.Handle, GWL_WNDPROC, Longint(FParentInstance));
  end;
end;

procedure Register;
begin
  RegisterComponents('Peter''s Components', [TIntellimouse]);
end;

end.

